/*
   This file provides practice with the operations described
   in "Linked list operations.txt".

   Follow the directions in this file to implement each of the
   folowing linked list operations on a singly linked list:
     1) compute the length of the list,
     2) search the list for an element,
     3) select a node by its position (index) in the list,
     4) copy the list.

   Visualize your code with the Java Visualizer web site.
*/


/**
   This is a simple generic Node class.
*/
class Node<E>
{
   private E data;
   private Node<E> link;

   public Node(E data, Node<E> link)
   {
      this.data = data;
      this.link = link;
   }

   public E       getData( )            {return data;}
   public Node<E> getLink( )            {return link;}
   public void    setData(E data)       {this.data = data;}
   public void    setLink(Node<E> link) {this.link = link;}
}//Node<E>


/**
   Follow the directions below to implement each of the
   above four linked list operations on a linked list
   with a head pointer.
*/
public class PracticeWithLinkedLists
{
   public static void main(String[] args)
   {
      // Create the linked list [13, 17, 10, 12, 18, 14, 16].
      Node<Integer> head = new Node<>(13, new Node<>(17, new Node<>(10,
                           new Node<>(12, new Node<>(18, new Node<>(14,
                           new Node<>(16, null)))))));

      printLinkedList(head);

      // 1.) Compute the length of the list.
      int length = 0;





      // 2.) Search the list for the node containing 12.
      Node<Integer> selection = head;  // start searching at the beginning of the list





      // 3.) Select the fifth node in the list.
      int index = 4;
      selection = head;  // start counting from the beginning of the list





      // 4.) Make a copy of the list. Changes to the copy should not affect the original list.
      Node<Integer> copy = null;





   }//main()


   public static <E> void printLinkedList(Node<E> cursor)
   {
      System.out.print("[");
      if (null != cursor) // handle the first node
      {
         System.out.print(cursor.getData());
         cursor = cursor.getLink();
      }
      while (null != cursor) // start the loop on the second node
      {
         System.out.print(", " + cursor.getData());
         cursor = cursor.getLink();
      }
      System.out.println("]");
   }
}
