/*
   This file provides practice with the operations described
   in "Linked list operations.txt".

   Follow the directions in this file to implement each of the
   following linked list operations on a singly linked list:
      1) insert into an empty list,
      2) insert at the beginning of the list,
      3) insert after a selected node in the list,
      4) delete at the beginning of the list,
      5) delete after a selected node in the list.

   Visualize your code with the Java Visualizer web site.
*/

/**
   This is a simple generic Node class.
*/
class Node<E>
{
   private E data;
   private Node<E> link;

   public Node(E data, Node<E> link)
   {
      this.data = data;
      this.link = link;
   }

   public E       getData( )            {return data;}
   public Node<E> getLink( )            {return link;}
   public void    setData(E data)       {this.data = data;}
   public void    setLink(Node<E> link) {this.link = link;}
}//Node<E>


/**
   Follow the directions below to implement each of the
   above five linked list operations on a linked list
   with a head pointer and a cursor pointer.
*/
public class PracticeWithLinkingNodes
{
   public static void main(String[] args)
   {
      // Create an empty linked list with a head reference.
      Node<Integer> head = null;


      // 1.) Insert a node with data 100 into this empty list.




      // 2.) Insert a node with data 200 at the beginning of the list.




      // 3.) Insert a node with data 300 at the end of the list.




      Node<Integer> cursor = null;
      // The list now has three nodes. Move the cursor to the middle node.
      cursor = head.getLink();

      // 4.) Insert a node with data 400 after the cursor (but don't move the cursor).




      // The list should now be [200, 100, 400, 300], with the
      // cursor still pointed at the node containing 100.
      printLinkedList(head);

      // 5.) Delete the first node in the list (the one containing 200).




      // 6.) Delete the node after the cursor (the one containing 400).




      // 7.) Again, delete the node after the cursor (the one containing 300).




      // 8.) Delete the single remaining node from the list (the one containing 100).




      // Make sure that head is null.
      if ( head != null )
         System.out.println("You did something wrong.");

   }//main()


   public static <E> void printLinkedList(Node<E> cursor)
   {
      System.out.print("[");
      if (null != cursor) // handle the first node
      {
         System.out.print(cursor.getData());
         cursor = cursor.getLink();
      }
      while (null != cursor) // start the loop on the second node
      {
         System.out.print(", " + cursor.getData());
         cursor = cursor.getLink();
      }
      System.out.println("]");
   }
}
