class Node<E>
{
   private E data;
   private Node<E> link;

   public Node(E data, Node<E> link)
   {
      this.data = data;
      this.link = link;
   }

   public E       getData( )            {return data;}
   public Node<E> getLink( )            {return link;}
   public void    setData(E data)       {this.data = data;}
   public void    setLink(Node<E> link) {this.link = link;}
}//Node<E>


public class PrintLinkedList
{
   public static void main(String[] args)
   {
      printLinkedList( null );
      printLinkedList( new Node<>(25, null) );
      printLinkedList( new Node<>(25, new Node<>(35, null)) );
      printLinkedList( new Node<>(25, new Node<>(35, new Node<>(45, null))) );
   }//main()


   public static <E> void printLinkedList(Node<E> cursor)
   {
      System.out.print("[");
      if (null != cursor) // handle the first node
      {
         System.out.print(cursor.getData());
         cursor = cursor.getLink();
      }
      while (null != cursor) // start the loop on the second node
      {
         System.out.print(", " + cursor.getData());
         cursor = cursor.getLink();
      }
      System.out.println("]");
   }
}
